/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WPRINTSF.C  */

#include "cxlstr.h"
#include "cxlwin.h"

int wprintsf(int wrow,int wcol,int attr,char *format,char *str)
{
    register int valid;
    char ch;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    while(*format) {
        switch(*format) {

            case '!':

                /* skip all command toggles */
                ch=*format++;
                while(*format!=ch) format++;
                break;

            case '\"':
            case '\'':

                /* display all text inside quotes */
                ch=*format++;
                while(*format!=ch) {
                    if(!*format) return(_winfo.errno=W_INVFORMT);
                    wprintc(wrow,wcol++,attr,*format++);
                }
                break;
            
            case ' ':

                /* skip readability spaces */
                break;

            case '<':

                /* find right angle bracket, and    */
                /* display current buffer character */
                while(*format!='>') {
                    if(!*format) return(_winfo.errno=W_INVFORMT);
                    format++;
                }
                wprintc(wrow,wcol++,attr,*str++);
                break;

            case '[':

                /* find right square bracket, and   */
                /* display current buffer character */
                while(*format!=']') {
                    if(!*format) return(_winfo.errno=W_INVFORMT);
                    format++;
                }
                wprintc(wrow,wcol++,attr,*str++);
                break;

            case '.':

                /* display decimal point */
                wprintc(wrow,wcol++,attr,*format);
                break;

            default:

                /* if current format character is a password character, */
                /* or field is a password field, then display a blank.  */
                /* otherwise, display the current buffer character.     */
                if((valid=cvaltype(*str,*format))==-1)
                    return(_winfo.errno=W_INVFORMT);
                ch=(valid&&*str)?(*str):('?');
                if(*str) str++;
                wprintc(wrow,wcol++,attr,
                        (*format=='P')?' ':ch);
        }
        format++;
    }

    /* return normally if string length <= format string length */
    return((_winfo.errno=*str?W_STRLONG:W_NOERROR));
}
