/*  CXL - Copyright (c) 1987-1990 by Mike Smedley - All Rights Reserved  */
/* WPUTC.C - displays a character inside active window */

#include <dos.h>
#include <stdio.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wputc(int ch)
{
    register int chat,ccol;
    int crow,border,cwcol,scol,wrow,wcol;
    int far *p;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* get coordinates from window's record */
    crow=_winfo.active->row;
    ccol=_winfo.active->column;
    scol=_winfo.active->scol;
    border=_winfo.active->border;

    /* test the input character for control characters */
    switch(ch) {
        case LF:
            crow++;
        case CR:
            ccol=scol+border;
            break;
        case BS:
            wreadcur(&wrow,&wcol);
            if(wrow+wcol) {
                if(ccol==(scol+border)) {
                    ccol=_winfo.active->ecol-border;
                    crow--;
                    if(crow<(_winfo.active->srow+border)) crow++;
                }
                else {
                    ccol--;
                }
            }
            break;
        case HT:
            cwcol=ccol-border-scol;
            ccol+=(tabstop(cwcol,_winfo.tabwidth)-cwcol);
            break;
        case BEL:
            beep();
            break;
        default:
            if(_vinfo.usebios) {
                putchat(ch,_winfo.active->attr);
            }
            else {
                /* calculate address in video RAM */
                p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);
                chat=(((int)_winfo.active->attr<<8)|(ch&0x00ff));
                if(_vinfo.cgasnow)
                    cgawrword(p,chat);
                else
                    *p=chat;
                p++;
            }
            ccol++;
    }

    /* see if wrap-around is needed */
    if(ccol>(_winfo.active->ecol-border)) {
        ccol=scol+border;
        crow++;
    }

    /* see if scroll is needed */
    if(crow>(_winfo.active->erow-border)) {
        wscroll(1,SUP);
        crow--;
    }

    /* update window's record */
    _winfo.active->row=crow;
    _winfo.active->column=ccol;

    /* reset cursor position */
    gotoxy_(crow,ccol);                 

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
