/*  CXL - Copyright (c) 1987-1990 by Mike Smedley - All Rights Reserved  */
/*  WPUTS.C - displays a string inside active window  */

#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

static char *process_esc(char *str);

int wputs(char *str)
{
    register unsigned char *ccol;
    register int chat;
    unsigned char *crow,cwcol,border,scol;
    int wrow,wcol;
    char *q;
    int far *p;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* get effective coordinates from window's record */
    crow  =&(_winfo.active->row);
    ccol  =&(_winfo.active->column);
    scol  =_winfo.active->scol;
    border=_winfo.active->border;

    /* do while not end of string */
    for(q=str;*q;q++) {

        /* test the input character for control characters */
        switch(*q) {
            case LF:
                (*crow)++;
            case CR:
                *ccol=scol+border;
                break;
            case BS:
                gotoxy_(*crow,*ccol);
                wreadcur(&wrow,&wcol);
                if(wrow+wcol) {
                    if(*ccol==(scol+border)) {
                        *ccol=_winfo.active->ecol-border;
                        (*crow)--;
                        if(*crow<(_winfo.active->srow+border)) (*crow)++;
                    }
                    else {
                        (*ccol)--;
                    }
                }
                break;
            case HT:
                cwcol=(*ccol)-border-scol;
                (*ccol)+=(tabstop(cwcol,_winfo.tabwidth)-cwcol);
                break;
            case BEL:
                beep();
                break;
            case ESC:
                q=process_esc(q);
                break;
            default:
                if(_vinfo.usebios) {
                    gotoxy_(*crow,*ccol);
                    putchat(*q,_winfo.active->attr);
                }
                else {
                    /* calculate address in video RAM */
                    p=MK_FP(_vinfo.videoseg,(((*crow)*_vinfo.numcols)+*ccol)*2);
                    chat=(((int)_winfo.active->attr<<8)|(*q&0x00ff));
                    if(_vinfo.cgasnow)
                        cgawrword(p,chat);
                    else
                        *p=chat;
                    p++;
                }
                (*ccol)++;
        }

        /* see if wrap-around is needed */
        if( (*ccol) > (_winfo.active->ecol-border) ) {
            *ccol=scol+border;
            (*crow)++;
        }

        /* see if scroll is needed */
        if( (*crow) > (_winfo.active->erow-border) ) {
            wscroll(1,SUP);
            (*crow)--;
        }
    }

    /* reset cursor position */
    gotoxy_(*crow,*ccol);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

/*---------------------------------------------------------------------------*/

/* this function will process an Escape sequence when encountered */

static char *process_esc(char *str)
{
    register int attr;
    char *p;
    int ch,wrow,wcol;

    attr=_winfo.active->attr;
    for(p=str;*p==ESC;p++) {
        switch(*++p) {
            case '+':   /* increase text attribute */
                wtextattr(++attr);
                break;
            case '-':   /* decrease text attribute */
                wtextattr(--attr);
                break;
            case 'A':   /* change attribute */
                wtextattr(*++p);
                break;
            case 'F':   /* change foreground attribute */
                wtextattr((*++p&7)|(attr&248));
                break;
            case 'B':   /* change background attribute */
                wtextattr((*++p&112)|(attr&143));
                break;
            case 'I':   /* toggle intensity bit */
                wtextattr((attr&8)?(attr&247):(attr|8));
                break;
            case 'L':   /* toggle blinking bit */
                wtextattr((attr&128)?(attr&127):(attr|128));
                break;
            case 'X':   /* reverse attribute */
                wtextattr(revsattr(attr));
                break;
            case 'R':   /* set cursor row */
                wreadcur(&wrow,&wcol);
                wgotoxy(*++p,wcol);
                break;
            case 'C':   /* set cursor column */
                wreadcur(&wrow,&wcol);
                wgotoxy(wrow,*++p);
                break;
            case 'E':   /* erase */
                switch(*++p) {
                    case 'W':   /* erase window */
                        wclear();
                        break;
                    case 'S':   /* erase to end of window */
                        wclreos();
                        break;
                    case 'L':   /* erase to end of window's line */
                        wclreol();
                        break;
                }
                break;
            case 'D':   /* duplicate character */
                ch=*++p;
                wdupc(ch,*++p);
                break;
            default:
                p--;
        }
    }
    return(--p);
}
