/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSAVE.C - wsave() saves a window of the screen
              wrestore() restores a previously saved window to the screen  */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int *wsave(int srow,int scol,int erow,int ecol)
{
    register int ccol,crow;
    int *q,*wbuf,bytes,soffs,width,oneline;
    int far *p;

    /* allocate buffer to hold window's contents */
    if((wbuf=malloc(((erow-srow+1)*(ecol-scol+1)+4)*2))!=NULL) {

        /* calculate info on window */
        width=ecol-scol+1;
        bytes=width*2;
        soffs=(srow*_vinfo.numcols+scol)*2;
        oneline=_vinfo.numcols*2;

        /* write window's coordinates to allocated buffer */
        q=wbuf;
        *q++=srow;
        *q++=scol;
        *q++=erow;
        *q++=ecol;

        /* do for all rows in window */
        for(crow=srow;crow<=erow;crow++) {
            if(_vinfo.usebios) {
               for(ccol=scol;ccol<=ecol;ccol++) {
                    gotoxy_(crow,ccol);
                    *q++=readchat();
                }
            }
            else {
                if(_vinfo.cgasnow) {
                    p=MK_FP(_vinfo.videoseg,soffs);
                    cgareadn(p,q,width);
                }
                else {
                    p=(int far *)q;
                    movedata(_vinfo.videoseg,soffs,FP_SEG(p),FP_OFF(p),bytes);
                }
                soffs+=oneline;
                q+=width;
            }
        }
    }

    /* return address of window's buffer */
    return(wbuf);                       
}

/*---------------------------------------------------------------------------*/

void wrestore(int *wbuf)
{
    register int ccol,crow;
    int *q,srow,scol,erow,ecol,bytes,doffs,width,oneline;
    int far *p;

    /* get coordinates from window's buffer */
    q=wbuf;                             
    srow=*q++;
    scol=*q++;
    erow=*q++;
    ecol=*q++;

    /* calculate info on window */
    width=ecol-scol+1;
    bytes=width*2;
    doffs=(srow*_vinfo.numcols+scol)*2;
    oneline=_vinfo.numcols*2;

    /* do for all rows in window */
    for(crow=srow;crow<=erow;crow++) {
        if(_vinfo.usebios) {
           for(ccol=scol;ccol<=ecol;ccol++) {
                gotoxy_(crow,ccol);
                putchat(*q,(*q)>>8);
                q++;
            }
        }
        else {
            if(_vinfo.cgasnow) {
                p=MK_FP(_vinfo.videoseg,doffs);
                cgawriten(q,p,width);
            }
            else {
                p=(int far *)q;
                movedata(FP_SEG(p),FP_OFF(p),_vinfo.videoseg,doffs,bytes);
            }
            doffs+=oneline;
            q+=width;
        }
    }

    /* free window's buffer */
    free(wbuf);                         
}


