/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSCANF.C   - inputs a formatted string from active window   */

#include <stdarg.h>
#include <stdio.h>
#include "cxlwin.h"

#if     !defined(__TURBOC__)
#error  wscanf() is valid only in the Turbo C version
#else

#define MAXCHARS  160

int wscanf(const char *format,...)
{
    va_list argptr;
    char buf[MAXCHARS];

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* get string from keyboard into buffer */
    if(wgets(buf)) return(_winfo.errno);

    /* process arguments from supplied argument list using given format */
    va_start(argptr,format);            /* access argument list */
    vsscanf(buf,format,argptr);         /* scan input string for arguments */
    va_end(argptr);                     /* end access of argument list */

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

#endif
