/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSCROLLB.C   - scrolls a region of the active window up or down  */

#include <dos.h>
#include "cxlwin.h"

int wscrollbox(int wsrow,int wscol,int werow,int wecol,int count,int direction)
{
    register int numrows,border,ssrow,serow;
    union REGS regs;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid coordinates */
    if(wchkbox(wsrow,wscol,werow,wecol)) return(_winfo.errno=W_INVCOORD);

    /* check for window border */
    border=_winfo.active->border;

    /* check scroll count against number of rows in scroll boundary */
    ssrow   = _winfo.active->srow+wsrow+border;
    serow   = _winfo.active->srow+werow+border;
    numrows = serow - ssrow + 1;
    if(count > numrows) count=numrows;

    /* use BIOS function call 6 (up) or 7 (down) to scroll window */
    regs.h.bh=_winfo.active->wattr;
    regs.h.ch=ssrow;
    regs.h.cl=_winfo.active->scol+wscol+border;
    regs.h.dh=serow;
    regs.h.dl=_winfo.active->scol+wecol+border;
    regs.h.al=count;
    regs.h.ah=((direction==SDOWN)?7:6);
    int86(0x10,&regs,&regs);

    /* return with no error */
    return(_winfo.errno=W_NOERROR);
}
