/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSHADOFF.C  - removes shadow from active window  */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "cxlvid.h"
#include "cxlwin.h"

int wshadoff(void)
{
    int *q,ccol,crow,srow,scol,erow,ecol,stop,chat;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* if window doesn't have a shadow, ignore request */
    if(_winfo.active->wsbuf==NULL) return(_winfo.errno=W_NOERROR);

    /* get window coordinates from the window's record */
    srow=_winfo.active->srow;
    scol=_winfo.active->scol;
    erow=_winfo.active->erow;
    ecol=_winfo.active->ecol;

    /* start at upper right corner of shadow and work down */
    crow=srow+1;
    ccol=ecol+1;
    q=_winfo.active->wsbuf;

    /* delete shadow to right of window */
    while(crow<=erow) {
        chat=*q++;
        printc(crow,ccol,chat>>8,chat);
        chat=*q++;
        printc(crow++,ccol+1,chat>>8,chat);
    }

    /* start at lower left corner of shadow and work right */
    crow=erow+1;
    ccol=scol+2;
    stop=ecol+2;

    /* delete bottom shadow */
    while(ccol<=stop) {
        chat=*q++;
        printc(crow,ccol++,chat>>8,chat);
    }

    /* free memory held by shadow */
    free(_winfo.active->wsbuf);

    /* update window's record */
    _winfo.active->wsbuf=NULL;
    _winfo.active->wsattr=0xff;

    /* return with no error */
    return(_winfo.errno=W_NOERROR);
}
 
