/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSHADOW.C   - gives active window a shadow  */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "cxlvid.h"
#include "cxlwin.h"

int wshadow(int attr)
{
    register int *wsbuf,*q;
    int far *p;
    int ccol,crow,incr,srow,scol,erow,ecol,stop,chat1,chat2;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* see if window already has a shadow */
    if(_winfo.active->wsbuf!=NULL) return(_winfo.errno=W_NOERROR);

    /* get window coordinates from the window's record */
    srow=_winfo.active->srow;
    scol=_winfo.active->scol;
    erow=_winfo.active->erow;
    ecol=_winfo.active->ecol;

    /* allocate buffer to hold shadow's contents */
    if((wsbuf=malloc((((erow-srow)*2)+ecol-scol+1)*2))==NULL)
        return(_winfo.errno=W_ALLOCERR);

    /* check for/adjust to monochrome attributes */
    attr=mapattr(attr);

    /* start at upper right corner of shadow and work down */
    crow=srow+1;
    ccol=ecol+1;
    q=wsbuf;

    /* if not using BIOS video writes, calculate screen offset */
    if(!_vinfo.usebios) {
        p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);
        incr=_vinfo.numcols-1;
    }

    /* draw shadow to right of window */
    while(crow<=erow) {

        /* read current screen characters/attributes */
        if(_vinfo.usebios) {
            gotoxy_(crow,ccol);
            chat1=readchat();
            gotoxy_(crow,ccol+1);
            chat2=readchat();
        }
        else {
            chat1=((_vinfo.cgasnow)?cgardword(p):*p);
            p++;
            chat2=((_vinfo.cgasnow)?cgardword(p):*p);
            p+=incr;
        }

        /* save in shadow's buffer */
        *q++=chat1;
        *q++=chat2;

        /* write characters back to screen using shadow's attribute */
        printc(crow,ccol,(chat1&0x8000)?(attr|BLINK):attr,chat1);
        printc(crow++,ccol+1,(chat2&0x8000)?(attr|BLINK):attr,chat2);
    }

    /* start at lower left corner of shadow and work right */
    crow=erow+1;
    ccol=scol+2;
    stop=ecol+2;

    if(!_vinfo.usebios)
        p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);

    /* draw bottom shadow */
    while(ccol<=stop) {

        /* read current screen character/attribute */
        if(_vinfo.usebios) {
            gotoxy_(crow,ccol);
            chat1=readchat();
        }
        else {
            chat1=((_vinfo.cgasnow)?cgardword(p):*p);
            p++;
        }

        /* save in shadow's buffer */
        *q++=chat1;

        /* write character back to screen using shadow's attribute */
        printc(crow,ccol++,(chat1&0x8000)?(attr|BLINK):attr,chat1);
    }

    /* save info in window's record */
    _winfo.active->wsbuf  = wsbuf;
    _winfo.active->wsattr = attr;

    /* reset cursor */
    if(_vinfo.usebios) gotoxy_(_winfo.active->row,_winfo.active->column);

    /* return with no error */
    return(_winfo.errno=W_NOERROR);
}
