/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSIZE.C     - resizes the active window  */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wsize(int nerow,int necol)
{
    register int chat,ccol;
    int *newbuf,*src,*dest,crow,mrow,mcol,shattr=-1;
    int far *p;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid coordinates */
    if((nerow<=_winfo.active->srow+_winfo.active->border)||
       (necol<=_winfo.active->scol+_winfo.active->border))
        return(_winfo.errno=W_INVCOORD);

    /* allocate memory block for new size */
    if((newbuf=malloc(((nerow-_winfo.active->srow+1)*
       (necol-_winfo.active->scol+1)+4)*2))==NULL)
        return(_winfo.errno=W_ALLOCERR);

    /* if window has shadow, close it before the sizing */
    if(_winfo.active->wsbuf!=NULL) {
        shattr=_winfo.active->wsattr;
        wshadoff();
    }

    /* calculate maximum row and maximum column of scan */
    if(nerow>_winfo.active->erow) mrow=nerow; else mrow=_winfo.active->erow;
    if(necol>_winfo.active->ecol) mcol=necol; else mcol=_winfo.active->ecol;

    /* transfer needed contents of old buffer to new buffer */
    src=_winfo.active->wbuf+4;
    dest=newbuf+4;
    for(crow=_winfo.active->srow;crow<=mrow;crow++) {
        for(ccol=_winfo.active->scol;ccol<=mcol;ccol++) {
            if( (crow>nerow && ccol>_winfo.active->ecol)
                || (crow>_winfo.active->erow && ccol>necol) ) {
                continue;
            }
            if( crow>_winfo.active->erow || ccol>_winfo.active->ecol ) {
                p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);
                if(_vinfo.usebios) {
                    gotoxy_(crow,ccol);
                    *dest++=readchat();
                    putchat(_winfo.fillch,_winfo.active->wattr);
                }
                else {
                    *dest++=((_vinfo.cgasnow)?cgardword(p):*p);
                    chat= (_winfo.fillch) | (_winfo.active->wattr<<8);
                    if(_vinfo.cgasnow)
                        cgawrword(p,chat);
                    else
                        *p=chat;
                }
            }
            else {
                if( crow>nerow || ccol>necol ) {
                    if(_vinfo.usebios) {
                        gotoxy_(crow,ccol);
                        putchat(*src,(*src)>>8);
                    }
                    else {
                        p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);
                        if(_vinfo.cgasnow)
                            cgawrword(p,*src);
                        else
                            *p=*src;
                    }
                    src++;
                }
                else {
                    if((crow==_winfo.active->erow||ccol==_winfo.active->ecol)&&
                       _winfo.active->border) {
                        if(_vinfo.usebios) {
                            gotoxy_(crow,ccol);
                            putchat(_winfo.fillch,_winfo.active->wattr);
                        }
                        else {
                            p=MK_FP(_vinfo.videoseg,((crow*_vinfo.numcols)+ccol)*2);
                            chat= (_winfo.fillch) | (_winfo.active->wattr<<8);
                            if(_vinfo.cgasnow)
                                cgawrword(p,chat);
                            else
                                *p=chat;
                        }
                    }
                    *dest++=*src++;

                }
            }
        }
    }

    /* free old window's buffer */
    free(_winfo.active->wbuf);

    /* update cursor coordinates if neccessary */
    if((_winfo.active->row>(nerow-_winfo.active->border))
        ||(_winfo.active->column>(necol-_winfo.active->border))) {
        wgotoxy(0,0);
    }

    /* update window's record */
    _winfo.active->wbuf  = newbuf;
    _winfo.active->erow  = nerow;
    _winfo.active->ecol  = necol;

    /* update window buffer's header */
    *(newbuf)   = _winfo.active->srow;
    *(newbuf+1) = _winfo.active->scol;
    *(newbuf+2) = nerow;
    *(newbuf+3) = necol;

    /* redraw border if one exists */
    if(_winfo.active->border) wborder(_winfo.active->btype);

    /* if window has shadow, then re-open it */
    if(shattr!=-1) wshadow(shattr);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
