/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WSLIDE.C  - slides active window to a new location     */

#include "cxlvid.h"
#include "cxlwin.h"

int wslide(int nsrow,int nscol)
{
    register int shattr=-1,err=0;

    /* check for active windows */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid coordinates */
    if(nsrow<0||nscol<0) return(_winfo.errno=W_INVCOORD);

    /* if window has shadow, close it before the move */
    if(_winfo.active->wsbuf!=NULL) {
        shattr=_winfo.active->wsattr;
        wshadoff();
    }

    /* slide it on over */
    while(_winfo.active->scol>nscol && !err) err=wdrag(D_LEFT);
    while(_winfo.active->scol<nscol && !err) err=wdrag(D_RIGHT);
    while(_winfo.active->srow>nsrow && !err) err=wdrag(D_UP);
    while(_winfo.active->srow<nsrow && !err) err=wdrag(D_DOWN);

    /* test for error */
    if(_winfo.errno) return(_winfo.errno);

    /* if window has shadow, redraw it */
    if(shattr!=-1) wshadow(shattr);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
