/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WUNHIDE.C   - unhides a previously hidden window    */

#include "cxlvid.h"
#include "cxlwin.h"

int wunhide(WINDOW whandle)
{
    int *p;
    struct _wrec_t *found;

    /* check pointer to hidden window linked list ; must not be NULL */
    if(_winfo.hidden==NULL) return(_winfo.errno=W_NOHIDDEN);

    /* check to see if input window handle == 0.  if so, then */
    /* that means to unhide the most recently hidden window.  */
    if(!whandle) whandle=_winfo.hidden->whandle;

    /* scan through linked list for record belonging to requested handle */
    found=_winfo.hidden;
    while(found!=NULL) {
        if(whandle==found->whandle) break;
        found=found->prev;
    }

    /* was handle found in hidden window record linked list? */
    if(found==NULL) {

        /* see if handle is in visible window record linked list */
        if(wfindrec(whandle)==NULL)
            return(_winfo.errno=W_NOTFOUND);
        else
            return(_winfo.errno=W_NOTHIDD);
    }

    /* save area of screen where window is to unhide at */
    if((p=wsave(found->srow,found->scol,found->erow,found->ecol))==NULL)
        return(_winfo.errno=W_ALLOCERR);

    /* restore contents of hidden window back to screen */
    wrestore(found->wbuf);
    found->wbuf=p;

    /* update hidden window record linked list */
    if(found->prev!=NULL) found->prev->next=found->next;
    if(found->next==NULL)
        _winfo.hidden=found->prev;
    else
        found->next->prev=found->prev;

    /* update visible window record linked list */
    if(_winfo.active!=NULL) _winfo.active->next=found;
    found->prev=_winfo.active;
    found->next=NULL;
    _winfo.active=found;
    _winfo.total++;

    /* if window had a shadow before hiding, give it one again */
    if(_winfo.active->wsattr!=0xff) wshadow(_winfo.active->wsattr);

    /* update help category */
    if(_winfo.active->help!=NULL) _winfo.help=_winfo.active->help;

    /* reset cursor */
    gotoxy_(_winfo.active->row,_winfo.active->column);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

