/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WUNLINK.C -  unlinks and frees a window from memory, but does not
                 manipulate the screen at all */

#include <stdlib.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wunlink(WINDOW w)
{
    struct _wrec_t *found,*prev,*next;

    /* check to see if input window handle == 0.  if    */
    /* so, then that means to unlink the active window. */
    if(!w) w=_winfo.active->whandle;

    /* find address of window record for given window handle */
    if((found=wfindrec(w))==NULL) return(_winfo.errno=W_NOTFOUND);

    /* free memory held by shadow's buffer (if shadow exists) */
    if(found->wsbuf!=NULL) free(found->wsbuf);

    /* free memory held by window's buffer */
    free(found->wbuf);

    /* decrement total number of open windows */
    _winfo.total--;

    /* re-link list pointers around window record to remove */
    prev=found->prev;
    next=found->next;
    if(prev!=NULL) prev->next=next;
    if(next!=NULL) next->prev=prev;

    /* free memory held by window record */
    free(found);

    /* see if active window has changed */
    if(next==NULL) {
        if(prev!=NULL) {
            _winfo.active=prev;
            if(_winfo.active->help) _winfo.help=_winfo.active->help;
        }
    }

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

